package com.clx.performance.controller.sdk;

import com.alibaba.fastjson.JSON;
import com.clx.performance.sdk.constant.ActionConstants;
import com.clx.performance.sdk.request.action.PaymentSettlementAction;
import com.clx.performance.service.settle.third.ThirdSettlementOwnerService;
import com.msl.common.dto.HttpDTO;
import com.msl.common.result.Result;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Objects;

import static org.bouncycastle.cms.CMSSignedGenerator.DATA;

@Api(tags = "第三方")
@RestController
@RequestMapping("/encrypt/third")
@Slf4j
@AllArgsConstructor
public class ThirdPartyController {

    private final ThirdSettlementOwnerService thirdSettlementOwnerService;


    @PostMapping("/doAction")
    public Object doAction(HttpServletRequest request) {
        HttpDTO httpDTO = (HttpDTO) request.getAttribute(DATA);
        String action = httpDTO.getAction();
        if (Objects.equals(action, ActionConstants.PAYMENT_SETTLEMENT)) {
            thirdSettlementOwnerService.updateThirdPaymentSettlement(JSON.parseObject(httpDTO.getData(), PaymentSettlementAction.class));
        }
        return Result.ok();
    }
}
